/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
#include <QFileDialog.h>
#include <QMessagebox.h>   
#include <qfile.h>
#include <qapplication.h>
#include <qtextbrowser.h>
#include <qstringlist.h> 
#include <qstatusbar.h> 


void Test_Cost_Calculator::fileNew()
{

     qWarning( "not yet implemented!" );
}


void Test_Cost_Calculator::fileOpen()
{

 /*
 			*  Open a file dialog for loading.  
			*  The default directory is the current directory,
 */

    QStringList files = QFileDialog::getOpenFileNames(
                            "Files (*.txt *.asc *.dat *.csv)",
                            "",
                            this,
                            "open files dialog"
                            "Select one or more files to open" );

    QStringList list = files;

    QStringList::Iterator it = list.begin();

    while( it != list.end() ) {
    	FileName->setText(*it);
        ++it;
    } 
	
	QFile file(FileName->text());

	QTextStream stream(&file);
	QString inputline;
 
	file.open(IO_ReadOnly);
	
 	inputline = stream.readLine();

	CodeName->setText(inputline.section(',',0,0));  // code name

 		SST->setText(inputline.section(',',1,1));
 		MST->setText(inputline.section(',',2,2));
 		No_Of_Sites->setValue(inputline.section(',',3,3).toInt());
 		YieldVal->setText(inputline.section(',',4,4));
 		UptimeVal->setText(inputline.section(',',5,5));
 		IndexTimeVal->setText(inputline.section(',',6,6));
 		SysCostVal->setText(inputline.section(',',7,7));


#if 0
 		
 		CodeName->setText(stream.readLine());
 		SST->setText(stream.readLine());
 		MST->setText(stream.readLine());
 		No_Of_Sites->setValue(stream.readLine().toInt());
 		YieldVal->setText(stream.readLine());
 		UptimeVal->setText(stream.readLine());
 		IndexTimeVal->setText(stream.readLine());
 		SysCostVal->setText(stream.readLine());

#endif

	file.close(); 
	
	statusBar()->message(FileName->text());
}


void Test_Cost_Calculator::fileSave()
{
	QString fileName;
	QString msg;

	fileName = FileName->text();  // CodeName.append(".csv");

	QFile file(fileName);
 
	QTextStream out(&file);

	out.setEncoding(QTextStream::UnicodeUTF8);
 
	file.open(IO_WriteOnly);
	out << CodeName->text();
	out << ",";
	out << SST->text();
	out << ",";
	out << MST->text();
	out << ",";		
	out << No_Of_Sites->text();
	out << ",";		
	out << YieldVal->text();
	out << ",";		
	out << UptimeVal->text();
	out << ",";
	out << IndexTimeVal->text();
	out << ",";
	out << SysCostVal->text(); 
	file.close();

	/*= QFileDialog::getSaveFileName(".",  "*.csv",
                    this,
                    "save file dialog"
                    "Choose a filename to save under" );
	*/
	msg.append(fileName).append("...Saved");
	
	statusBar()->message(msg,2000);
}


void Test_Cost_Calculator::fileSaveAs()
{ 
	QString fileName;
	QString msg;

	fileName = QFileDialog::getSaveFileName(".",  "*.csv",
                    this,
                    "save file dialog"
                    "Choose a filename to save under" );
	 
	QFile file(fileName);
 
	QTextStream out(&file);

	out.setEncoding(QTextStream::UnicodeUTF8);
 
	file.open(IO_WriteOnly);
	out << CodeName->text();
	out << ",";
	out << SST->text();
	out << ",";
	out << MST->text();
	out << ",";		
	out << No_Of_Sites->text();
	out << ",";		
	out << YieldVal->text();
	out << ",";		
	out << UptimeVal->text();
	out << ",";
	out << IndexTimeVal->text();
	out << ",";
	out << SysCostVal->text(); 
	file.close();

	msg.append(fileName).append("...Saved");
	
	statusBar()->message(msg,2000);
}



void Test_Cost_Calculator::updateScrollBars()
{
     qApp->quit();
}


void Test_Cost_Calculator::updateAll()
{
	double Units_Per_Insertion;
	double Time_Per_Insertion;
	const double Seconds_Per_Hour = 3600;
	int Days_Per_Week;
	const int Hours_Per_Day = 24;
	double GUPH;
	double TempCost;

	QString newValue;

	Units_Per_Insertion =	 No_Of_Sites->text().toDouble() * YieldVal->text().toDouble();
	Time_Per_Insertion = MST->text().toDouble() + IndexTimeVal->text().toDouble()/1000;

	GUPH = (Seconds_Per_Hour/Time_Per_Insertion) * YieldVal->text().toDouble()/100 * No_Of_Sites->text().toDouble() * UptimeVal->text().toDouble()/100;

	QTextOStream( &newValue ) << (int) GUPH;

	GoodUnitsPerHourVal->setText(newValue);

	newValue = "";

	QTextOStream( &newValue ) << (int) (GUPH * Hours_Per_Day);

	GoodUnitsPerHourVal_2->setText(newValue);

	newValue = "";

	if (radioButton_4->isChecked()) { Days_Per_Week = 4; }
	if (radioButton_5->isChecked()) { Days_Per_Week = 5; }
	if (radioButton_6->isChecked()) { Days_Per_Week = 6; }
	if (radioButton_7->isChecked()) { Days_Per_Week = 7; }

	QTextOStream( &newValue ) << (int) (GUPH * Hours_Per_Day * Days_Per_Week);

	GoodUnitsPerHourVal_2_2->setText(newValue);

	newValue = "";

	TempCost = SysCostVal->text().toDouble()/GoodUnitsPerHourVal->text().toDouble();
 
	QTextOStream( &newValue ) << TempCost;

	newValue.sprintf("%5.4f",TempCost);
	//newValue.truncate(6);

	CostPerGoodDeviceVal->setText(newValue);
	
	statusBar()->message("Updated");

	/* let's make sure the sliders are in the right position */

	SysCostScrollBar->blockSignals(true);
	IndexScrollBar->blockSignals(true);
	UptimeScrollBar->blockSignals(true);
	YieldscrollBar->blockSignals(true);
	
	SysCostScrollBar->setValue(SysCostVal->text().toInt());
	IndexScrollBar->setValue(IndexTimeVal->text().toInt());
	UptimeScrollBar->setValue(UptimeVal->text().toInt());
	YieldscrollBar->setValue(YieldVal->text().toInt());
	
	SysCostScrollBar->blockSignals(false);
	IndexScrollBar->blockSignals(false);
	UptimeScrollBar->blockSignals(false);
	YieldscrollBar->blockSignals(false);

	/* end of slider moving, reenable event signals */
}


void Test_Cost_Calculator::helpIndex()
{

     qWarning( "not yet implemented!" );
}


void Test_Cost_Calculator::helpContents()
{
  
	QDir Dir;

	QString FName;

	FName = Dir.currentDirPath().append("\\doc\\html\\TCC_Help.htm");

	QString doc = FName;
 
	QTextBrowser* browser;

	browser = new QTextBrowser();
	browser->mimeSourceFactory();
	browser->setSource(doc);
	browser->setGeometry(50,50,600,400);
    browser->setCaption( "TCC - Help Document" );
 	browser->show();

}


void Test_Cost_Calculator::helpAbout()
{
QMessageBox::information(this, "About Test Cost Calculator",
 "This is the Test Cost Calculator Application\n"
 "\nOf course, you could do all this with Excel quite easily.\n\n"
 "This is an Open Source Program.  Source available on request.\n"
 "Copyright 2013 by Ross Reyes \n rossreyes@rcn.com \n");
}

void Test_Cost_Calculator::updateUptimeVal()
{
 
	QString newValue; 
	QTextOStream( &newValue ) << UptimeScrollBar->value();

	UptimeVal->setText(newValue);

}

void Test_Cost_Calculator::updateIndexVal()
{
	QString newValue; 
	QTextOStream( &newValue ) << IndexScrollBar->value();

	IndexTimeVal->setText(newValue);
}


void Test_Cost_Calculator::updateSysCostVal()
{
	QString newValue; 
	QTextOStream( &newValue ) << SysCostScrollBar->value();

	SysCostVal->setText(newValue);
}


void Test_Cost_Calculator::updateYieldVal()
{
	QString newValue; 
	QTextOStream( &newValue ) << YieldscrollBar->value();

	YieldVal->setText(newValue);
}


void Test_Cost_Calculator::updateDisplaySlot()
{

}


void Test_Cost_Calculator::fileExit()
{
	qApp->quit();
}

 
