#include "ate_ptemainwindowimpl.h"

 
#include <QTextEdit.h>
   
#include <qlcdnumber.h>
#include <qstring.h>
#include <qlineedit.h>
#include <qscrollbar.h>
#include <qspinbox.h>
#include <qfile.h>
#include <qstatusbar.h> 


ATE_PTEMainWindowImpl::ATE_PTEMainWindowImpl( QWidget* parent, const char* name, WFlags f )
	: Test_Cost_Calculator( parent, name, f )
{
 
 	//connect(this,SIGNAL(load(const QString&)),SLOT(readOpenFile(const QString&)));

	setCaption("ATE_PTE");
	setPTE();
	setInitVals();
	statusBar()->message("Ready");
 
}


void ATE_PTEMainWindowImpl::updateDisplaySlot()
{
	//   MSE = (1-((MSTime-SSTime)/((No_Of_Sites -1)*SSTime[testname])))*100

	QString Error = "Err";
	double MSE;
	double MSTime;
	double SSTime; 
	double N; // number of sites
	  
	SSTime = SST->text().toDouble();
	MSTime = MST->text().toDouble();
	N = No_Of_Sites->text().toDouble();

	MSE = ( 1- ( (MSTime-SSTime) / ( (N - 1) * SSTime) ) ) *100;

	if (MSE > 100) {
		PTE_LCD_Display->display(Error);
	} else {
		PTE_LCD_Display->display(MSE);
	}

	// Update all of the test cost data
	updateAll();

	statusBar()->message("Updated");
}

void ATE_PTEMainWindowImpl::setPTE()
{
  
	double MSTime;
	double SSTime; 
	double N; // number of sites

	SSTime = SST->text().toDouble();
	MSTime = MST->text().toDouble();
	N = No_Of_Sites->text().toDouble();

	PTE = ( 1- ( (MSTime-SSTime) / ( (N - 1) * SSTime) ) ) * 100;

}

double ATE_PTEMainWindowImpl::getPTE()
{

	return  PTE;

}


void ATE_PTEMainWindowImpl::setInitVals()
{ 
 
	/* block signals so we can reposition the scroll bars to initial values */

	QString newValue; 
	YieldVal->blockSignals(true);
	UptimeVal->blockSignals(true);
	IndexTimeVal->blockSignals(true);
	SysCostVal->blockSignals(true);

	QTextOStream( &newValue ) << YieldscrollBar->value();
	YieldVal->setText(newValue);

	newValue = ""; 
	QTextOStream( &newValue ) << UptimeScrollBar->value();
	UptimeVal->setText(newValue);
	
	newValue = ""; 
	QTextOStream( &newValue ) << IndexScrollBar->value();
	IndexTimeVal->setText(newValue); 
  
	newValue = "";  
	QTextOStream( &newValue ) << SysCostScrollBar->value();
	SysCostVal->setText(newValue);

	YieldVal->blockSignals(false);
	UptimeVal->blockSignals(false);
	IndexTimeVal->blockSignals(false);
	SysCostVal->blockSignals(false);

	/* unblock and update all */

	updateAll();

}




